fn main() {
  let x = vec![1, 2, 3];
  let mut x_iter = x.iter();  // next 时改变当前位置

  // for i in x_iter {
  //     println!("{}", i);
  // }

  assert_eq!(x_iter.next(), Some(&1));
  assert_eq!(x_iter.next(), Some(&2));

  let x: Vec<i32> = vec![1, 2, 3];
  let y: Vec<_> = x.iter().map(|x| x+1).collect();
  println!("x: {:?}, y:{:?}", x, y);  // x: [1, 2, 3], y:[2, 3, 4]
}
